#include <d3d8.h>

#include ".\GSEdit.h"
#include ".\GSMenu.h"
#include ".\LD12.h"



CGSEdit::CGSEdit()
{

  m_CurTile = LD12::TILE_WINDOW_1;

  m_CurLevel              = 1;
  m_ButtonReleased        = false;
  m_NameMode              = false;

  m_Level.Load( m_CurLevel );

}



CGSEdit::~CGSEdit()
{

}



void CGSEdit::Display( IDirect3DDevice8* pDevice )
{

  D3DVIEWPORT8    ViewPort;

  ViewPort.X = 0;
  ViewPort.Y = 0;
  ViewPort.Width = 640;
  ViewPort.Height = 440;
  ViewPort.MinZ = 0.0f;
  ViewPort.MaxZ = 1.0f;

  theApp.m_pd3dDevice->SetViewport( &ViewPort );

  m_Level.Render();

  m_Level.Render();

  theApp.m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1 );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1 );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );

  theApp.RenderTextureSection( theApp.m_MouseX - 10, theApp.m_MouseY - 10, theApp.m_Tiles[m_CurTile] );

  theApp.m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
  theApp.m_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_MODULATE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
  theApp.m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );

  // display clipped stuff

  ViewPort.Height = 480;
  theApp.m_pd3dDevice->SetViewport( &ViewPort );

  char      szTemp[200];

  wsprintf( szTemp, "Level: %d Money: %d Perc: %d Height: %d", m_CurLevel, m_Level.m_MoneyAvailable, m_Level.m_PercentageNeeded, m_Level.m_Height );
  theApp.Print( 2, 422, szTemp );

  if ( m_NameMode )
  {
    theApp.Print( 300, 422, "Name Mode" );
  }
  else
  {
    theApp.Print( 300, 422, "Tile Mode" );
  }
  std::string   Display = "Name:";
  Display += m_Level.m_Name;
  theApp.Print( 400, 422, Display.c_str() );

  theApp.Print( 2, 442, "+/- Modify current Item  1/2 Switch Level  3/4 Money 5/6 Percentage 7/8 Modify Height" );
  theApp.Print( 2, 462, "F2 Save level  N Enter Naming mode (exit with Enter)" );

}



void CGSEdit::UpdateFrame( const float fElapsedTime )
{

}



void CGSEdit::OnChar( int iChar )
{

  if ( m_NameMode )
  {
    if ( iChar == VK_BACK )
    {
      if ( m_Level.m_Name.length() )
      {
        m_Level.m_Name.resize( m_Level.m_Name.length() - 1 );
      }
    }
    else if ( iChar >= 32 )
    {
      m_Level.m_Name += (char)iChar;
    }
    return;
  }

  if ( iChar == 27 )
  {
    theApp.NextState( new CGSMenu() );
  }
  else if ( iChar == 'n' )
  {
    m_NameMode = true;
  }
  else if ( iChar == '+' )
  {
    m_CurTile = (LD12::TileTypes)( ( m_CurTile + 1 ) % LD12::TILE_LAST_ENTRY );
  }
  else if ( iChar == '-' )
  {
    m_CurTile = (LD12::TileTypes)( ( m_CurTile + LD12::TILE_LAST_ENTRY - 1 ) % LD12::TILE_LAST_ENTRY );
  }

}



void CGSEdit::OnMouse( int iX, int iY, int iButtons )
{

  int   Offset = (int)m_Level.m_LevelDisplayOffset;
  int   StartY = Offset / 32;
  int   DY = Offset % 32;

  int   TX = iX / 32;
  int   TY = StartY + ( iY + DY ) / 32;

  if ( iButtons & 1 )
  {
    m_Level.SetField( TX, TY, m_CurTile );
  }
  else if ( iButtons & 2 )
  {
    m_CurTile = m_Level.GetField( TX, TY );
  }
  if ( !( iButtons & 1 ) )
  {
    m_ButtonReleased = true;
  }

}



void CGSEdit::OnKeyDown( int iChar )
{

  if ( m_NameMode )
  {
    if ( iChar == VK_RETURN )
    {
      m_NameMode = false;
    }
    return;
  }

  if ( iChar == VK_F2 )
  {
    m_Level.Save( m_CurLevel );
  }
  else if ( iChar == '1' )
  {
    if ( m_CurLevel > 1 )
    {
      --m_CurLevel;
      m_Level.Load( m_CurLevel );
    }
  }
  else if ( iChar == '2' )
  {
    ++m_CurLevel;
    m_Level.Load( m_CurLevel );
  }
  else if ( iChar == '3' )
  {
    if ( m_Level.m_MoneyAvailable > 0 )
    {
      m_Level.m_MoneyAvailable -= 100;
    }
  }
  else if ( iChar == '4' )
  {
    m_Level.m_MoneyAvailable += 100;
  }
  else if ( iChar == '6' )
  {
    if ( m_Level.m_PercentageNeeded < 100 )
    {
      ++m_Level.m_PercentageNeeded;
    }
  }
  else if ( iChar == '5' )
  {
    if ( m_Level.m_PercentageNeeded > 0 )
    {
      --m_Level.m_PercentageNeeded;
    }
  }
  else if ( iChar == '7' )
  {
    if ( m_Level.m_Height > 14 )
    {
      m_Level.Resize( m_Level.m_Height - 1 );
    }
  }
  else if ( iChar == '8' )
  {
    if ( m_Level.m_Height < 1000 )
    {
      m_Level.Resize( m_Level.m_Height + 1 );
    }
  }
  else if ( iChar == VK_UP )
  {
    if ( m_Level.m_LevelDisplayOffset > 0.0f )
    {
      m_Level.m_LevelDisplayOffset -= 16.0f;
      if ( m_Level.m_LevelDisplayOffset < 0.0f )
      {
        m_Level.m_LevelDisplayOffset = 0.0f;
      }
    }
  }
  else if ( iChar == VK_DOWN )
  {
    if ( m_Level.m_LevelDisplayOffset < m_Level.m_Height * 32.0f - 440 )
    {
      m_Level.m_LevelDisplayOffset += 16.0f;
      if ( m_Level.m_LevelDisplayOffset > m_Level.m_Height * 32.0f - 440 )
      {
        m_Level.m_LevelDisplayOffset = m_Level.m_Height * 32.0f - 440;
      }
    }
  }

}



void CGSEdit::OnMouseWheel( int Delta )
{

  if ( Delta < 0 )
  {
    if ( m_Level.m_LevelDisplayOffset < m_Level.m_Height * 32.0f - 440 )
    {
      m_Level.m_LevelDisplayOffset += 16.0f;
      if ( m_Level.m_LevelDisplayOffset > m_Level.m_Height * 32.0f - 440 )
      {
        m_Level.m_LevelDisplayOffset = m_Level.m_Height * 32.0f - 440;
      }
    }
  }
  else if ( Delta > 0 )
  {
    if ( m_Level.m_LevelDisplayOffset > 0.0f )
    {
      m_Level.m_LevelDisplayOffset -= 16.0f;
      if ( m_Level.m_LevelDisplayOffset < 0.0f )
      {
        m_Level.m_LevelDisplayOffset = 0.0f;
      }
    }
  }

}