#pragma once

#include <set>

#include "LD12Types.h"



class Level;

class GameObject
{

  public:

    LD12::TextureTypes      m_Texture;
    LD12::GameObjectType    m_Type;

    std::set<int>           m_PushedByThese;

    int                     m_DispX;
    int                     m_DispY;
    float                   m_FractX;
    float                   m_FractY;

    float                   m_SpeedX;
    float                   m_SpeedY;
    float                   m_AccX;
    float                   m_AccY;
    float                   m_Angle;
    float                   m_AngleDelta;

    float                   m_LifeTime;
    float                   m_StartDelay;
    float                   m_ParticleHurtDelay;

    bool                    m_RemoveMe;

    int                     m_Number;

    int                     m_ObjIndex;
    int                     m_Power;

    bool                    m_Hidden;
    bool                    m_Collateral;


    GameObject();
    ~GameObject();

    void                    Render( Level& theLevel );
    void                    RenderFX( Level& theLevel );
    void                    Update( float ElapsedTime, Level& theLevel );
    void                    UpdatePhysicsStep( Level& theLevel );

};
